Summary: The PHP3 HTML-embedded scripting language for use with Apache.
Summary(fr): Le langage de script embarque-HTML PHP3 pour Apache.
Name: mod_php3
Version: 3.0.16
Release: 3mdk
%define apache_version 1.3.12
%define apache_release 12mdk
Group: System/Servers
Source0: http://www.php.net/distributions/php-%{version}.tar.bz2
#Source1: manual.tar.bz2
Source3: FAQ.php3
Source4: logo1t.gif
Source5: mod_php3.conf
Source6: php3.ini
Icon: php3.gif
Patch1: php-3.0.15-tokenbits.patch.bz2
Patch4: php-%{version}-config.patch.bz2
Patch6: ttf.patch.bz2
Copyright: GPL
BuildRoot: /var/tmp/%{name}-root
Requires: apache >= %{apache_version}-%{apache_release}, gd >= 1.7.3 t1lib, freetype, gdbm, zlib
Prereq: apache
BuildRequires: apache-devel >= %{apache_version}-%{apache_release}, gd-devel >= 1.7.3, t1lib-devel, freetype-devel, MySQL-devel >= 3.22.30, imap-devel, bison, byacc, gdbm-devel, postgresql-devel, zlib-devel
Conflicts: mod_php4, midgard-php
Packager: Jean-Michel Dault <jmdault@mandrakesoft.com>
Vendor: MandrakeSoft
Distribution: Linux-Mandrake

%description
PHP is an HTML-embedded scripting language.  PHP attempts to make it
easy for developers to write dynamically generated web pages.  PHP
also offers built-in database integration for several commercial
and non-commercial database management systems, so writing a
database-enabled web page with PHP is fairly simple.  The most
common use of PHP coding is probably as a replacement for CGI
scripts.  The mod_php module enables the Apache web server to
understand and process the embedded PHP language in web pages.

This package contains PHP3, or PHP version %{version}.  If you use
applications which specifically rely on PHP/FI, you should instead
install the PHP/FI module contained in the mod_php package.
If you're just starting with PHP, you should install this package.
You'll also need to install the Apache web server.

%description -l fr 
PHP est un langage de script embarque dans le HTM. PHP essaye de rendre 
simple aux developpeurs d'ecrire des pages web generees dynamiquement. 
PHP incorpore egalement une integration avec plusieurs systemes de gestion 
de bases de donnees commerciaux et non-connerciaux, qui rent facile      
la creation de pages web liees avec des bases de donnees. L'utilisation la
plus commune de PHP est probablement en remplacement de scripts CGI. Le
module mod_php permet au serveur web apache de comprendre et de traiter le
langage PHP integre dans des pages web.

Ce package contient PHP3, ou PHP version %{version}. Si vous utilisez des 
applications qui utilisent specifiquement PHP/FI, vous devrez installer le
module PHP/FI inclus dans le package mod_php. Si vous debutez avec PHP, vous
devriez installer ce package. Vous aurez egalement besoin d'installer le
serveur web Apache.

%package manual
Group: System/Servers
Summary: On-line manual for PHP3
Conflicts: mod_php4-manual, midgard-php-manual

%description manual
Comprehensive documentation for PHP3, viewable through any web
browser.

%package pgsql
Group: System/Servers
Requires: mod_php3, postgresql
Prereq: apache, mod_php3
Provides: mod_php3_database
Summary: PostgreSQL database module for PHP3.
Conflicts: mod_php4-pgsql, midgard-php-pgsql

%description pgsql
This is a dynamic shared object (DSO) for Apache that will add PostgreSQL
database support to PHP3.  If you need back-end support for PostgreSQL,
you should install this package in addition to the main mod_php3 package.

%package mysql
Group: System/Servers
Requires: mod_php3, mysql-shared-libs
Prereq: apache, mod_php3

Summary: MySQL database module for PHP3.
Conflicts: mod_php4-mysql, midgard-php-mysql

%description mysql
This is a dynamic shared object (DSO) for Apache that will MySQL
database support to PHP3.  If you need back-end support for MySQL,
you should install this package in addition to the main mod_php3 package.

%package imap
Group: System/Servers
Requires: mod_php3, imap
Prereq: apache, mod_php3
Summary: IMAP module for PHP3.
Conflicts: mod_php4-imap, midgard-php-imap

%description imap
This is a dynamic shared object (DSO) for Apache that will add IMAP
support to PHP3.  If you need to have IMAP support for PHP3 applications,
you will need to install this package in addition to the main mod_php3
package.

%package ldap
Group: System/Servers
Requires: mod_php3, openldap
Prereq: apache, mod_php3
Summary: LDAP module for PHP3.
Conflicts: mod_php4-ldap, midgard-php-ldap

%description ldap
This is a dynamic shared object (DSO) for Apache that will add LDAP
support to PHP3.  If you need to have LDAP support for PHP3 applications,
you will need to install this package in addition to the main mod_php3
package.


%prep
%setup -q -n php-%{version} 
%patch1 -p1
%patch4 -p1 -b .config
%patch6 -p1 
chown -R root.root .


#%build

autoconf
CFLAGS="-fPIC $RPM_OPT_FLAGS"	./configure \
	--with-apxs=/usr/sbin/apxs \
	--prefix=/usr \
	--with-gd \
	--with-zlib \
	--with-ttf=/usr/include/freetype/freetype.h \
	--enable-t1lib \
	--with-xml \
	--with-dbase \
	--with-filepro \
	--with-config-file-path=/etc/httpd/conf \
	--with-fdftk=no \
	--enable-debug=no \
	--enable-magic-quotes \
	--enable-debugger \
	--enable-bcmath \
	--enable-track-vars \
	--enable-safe-mode \
	--with-exec-dir=/usr/bin \
	--with-system-regex \
	--with-ftp \
	--with-versioning \
	--with-gdbm 

%build


make
make -C convertor

# PostgreSQL module
perl -pi -e 's/HAVE_PGSQL 0/HAVE_PGSQL 1/g' config.h
gcc -shared -fPIC -DHAVE_PQCMDTUPLES -DCOMPILE_DL=1 -I. -I/usr/include/apache \
	-I/usr/include/pgsql -o pgsql.so \
	./functions/pgsql.c -lpq -lc

# MySQL module
perl -pi -e 's/HAVE_MYSQL 0/HAVE_MYSQL 1/g' config.h
gcc -shared -fPIC -DCOMPILE_DL=1 -I. -I/usr/include/apache \
	-I/usr/include/mysql -o mysql.so \
	./functions/mysql.c -lmysqlclient -lc
 
# IMAP module
perl -pi -e 's/HAVE_IMAP 0/HAVE_IMAP 1/g' config.h
gcc -shared -fPIC -DCOMPILE_DL=1 -I. -I/usr/include/apache \
	-I/usr/include/imap -o imap.so ./functions/imap.c \
	/usr/lib/libc-client.a -lc

# LDAP module
perl -pi -e 's/HAVE_LDAP 0/HAVE_LDAP 1/g' config.h 
gcc -shared -fPIC -DCOMPILE_DL=1 -I. -I/usr/include/apache \
        -I/usr/include/ldap -o ldap.so ./functions/ldap.c -lldap -lc


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/lib/apache
mkdir -p $RPM_BUILD_ROOT/etc/httpd
mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf/addon-modules
mkdir -p $RPM_BUILD_ROOT/home/httpd/icons
mkdir -p $RPM_BUILD_ROOT/usr/bin
install -m 755 -s libphp3.so $RPM_BUILD_ROOT/usr/lib/apache
install -m 755 -s pgsql.so $RPM_BUILD_ROOT/usr/lib/apache
install -m 755 -s mysql.so $RPM_BUILD_ROOT/usr/lib/apache
install -m 755 -s imap.so $RPM_BUILD_ROOT/usr/lib/apache
install -m 755 -s ldap.so $RPM_BUILD_ROOT/usr/lib/apache
install -m 644 %{SOURCE6} $RPM_BUILD_ROOT/etc/httpd/conf/php3.ini
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT/home/httpd/icons
install -m 644 extra/icons/*.gif $RPM_BUILD_ROOT/home/httpd/icons
install -m 755 convertor/convertor $RPM_BUILD_ROOT/usr/bin/php-convertor
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT/etc/httpd/conf/addon-modules/mod_php3.conf
install -m 755 extra/gd/bdf2gdfont  $RPM_BUILD_ROOT/usr/bin/
mv convertor/README convertor/README.convertor

# manual
cd doc
ln -sf manual.html index.html
cd ..

%ifos linux
find $RPM_BUILD_ROOT/ -type 'f'|grep -E '.*[0-9]'|xargs file|grep troff\
|cut -d: -f1|xargs bzip2 -9
for i in $(find $RPM_BUILD_ROOT/usr/man/ -type 'l');do
 	TO=$(/bin/ls -l $i|awk '{print $NF}')
	ln -sf $TO.bz2 $i && mv $i $.bz2
done
for i in `find $RPM_BUILD_ROOT/ -type 'f' -perm '+a=x' ! -name 'lib*so*'`;do
    file $i|grep -q "not stripped" && strip $i
done
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
echo "Include conf/addon-modules/%{name}.conf" >> /etc/httpd/conf/httpd.conf
if [ -f /var/run/httpd.pid ]; then 
   /usr/sbin/apachectl restart
fi
ln -s /usr/doc/mod_php3-%{version} /home/httpd/html/addon-modules/mod_php3

%post manual
ln -s /usr/doc/mod_php3-manual-%{version} /home/httpd/html/addon-modules/mod_php3-manual

%postun manual
rm /home/httpd/html/addon-modules/mod_php3-manual

%postun
if [ `uname` = "Linux" ]; then perl="/usr/bin/perl"; fi
if [ `uname` = "SunOS" ]; then perl="/usr/local/bin/perl"; fi
$perl -pi -e "s|Include conf/addon-modules/%{name}.conf\n||g;" \
	/etc/httpd/conf/httpd.conf
if [ -f /var/run/httpd.pid ]; then 
   /usr/sbin/apachectl restart
fi
rm /home/httpd/html/addon-modules/mod_php3


%post imap
if [ `uname` = "Linux" ]; then perl="/usr/bin/perl"; fi
if [ `uname` = "SunOS" ]; then perl="/usr/local/bin/perl"; fi
$perl -pi -e 's|^;extension=imap.so|extension=imap.so|g' /etc/httpd/conf/php3.ini
if [ -f /var/run/httpd.pid ]; then 
   /usr/sbin/apachectl restart
fi

%postun imap
if [ `uname` = "Linux" ]; then perl="/usr/bin/perl"; fi
if [ `uname` = "SunOS" ]; then perl="/usr/local/bin/perl"; fi
if [ $1 = 0 ]; then
  $perl -pi -e 's|^extension=imap.so|;extension=imap.so|g' /etc/httpd/conf/php3.ini
fi
if [ -f /var/run/httpd.pid ]; then 
   /usr/sbin/apachectl restart
fi

%post ldap
if [ `uname` = "Linux" ]; then perl="/usr/bin/perl"; fi
if [ `uname` = "SunOS" ]; then perl="/usr/local/bin/perl"; fi
$perl -pi -e 's|^;extension=ldap.so|extension=ldap.so|g' /etc/httpd/conf/php3.ini
if [ -f /var/run/httpd.pid ]; then 
   /usr/sbin/apachectl restart
fi

%postun ldap
if [ `uname` = "Linux" ]; then perl="/usr/bin/perl"; fi
if [ `uname` = "SunOS" ]; then perl="/usr/local/bin/perl"; fi
if [ $1 = 0 ]; then
  $perl -pi -e 's|^extension=ldap.so|;extension=ldap.so|g' /etc/httpd/conf/php3.ini
fi
if [ -f /var/run/httpd.pid ]; then 
   /usr/sbin/apachectl restart
fi

%post pgsql
if [ `uname` = "Linux" ]; then perl="/usr/bin/perl"; fi
if [ `uname` = "SunOS" ]; then perl="/usr/local/bin/perl"; fi
$perl -pi -e 's|^;extension=pgsql.so|extension=pgsql.so|g' /etc/httpd/conf/php3.ini
if [ -f /var/run/httpd.pid ]; then 
   /usr/sbin/apachectl restart
fi

%postun pgsql
if [ `uname` = "Linux" ]; then perl="/usr/bin/perl"; fi
if [ `uname` = "SunOS" ]; then perl="/usr/local/bin/perl"; fi
if [ $1 = 0 ]; then
  $perl -pi -e 's|^extension=pgsql.so|;extension=pgqsl.so|g' /etc/httpd/conf/php3.ini
fi
if [ -f /var/run/httpd.pid ]; then 
   /usr/sbin/apachectl restart
fi

%post mysql
if [ `uname` = "Linux" ]; then perl="/usr/bin/perl"; fi
if [ `uname` = "SunOS" ]; then perl="/usr/local/bin/perl"; fi
$perl -pi -e 's|^;extension=mysql.so|extension=mysql.so|g' /etc/httpd/conf/php3.ini
if [ -f /var/run/httpd.pid ]; then 
   /usr/sbin/apachectl restart
fi

%postun mysql
if [ `uname` = "Linux" ]; then perl="/usr/bin/perl"; fi
if [ `uname` = "SunOS" ]; then perl="/usr/local/bin/perl"; fi
if [ $1 = 0 ]; then
  $perl -pi -e 's|^extension=mysql.so|;extension=mysql.so|g' /etc/httpd/conf/php3.ini
fi
if [ -f /var/run/httpd.pid ]; then 
   /usr/sbin/apachectl restart
fi


%files
%defattr(-,root,root)
/usr/lib/apache/libphp3.so
%config /etc/httpd/conf/php3.ini
%config /etc/httpd/conf/addon-modules/mod_php3.conf
/home/httpd/icons/*
%doc CODING_STANDARDS CREDITS ChangeLog LICENSE BUGS examples
%doc INSTALL* 
%doc convertor/README.convertor
/usr/bin/*

%files pgsql
%defattr(-,root,root)
/usr/lib/apache/pgsql.so

%files mysql
%defattr(-,root,root)
/usr/lib/apache/mysql.so

%files imap
%defattr(-,root,root)
/usr/lib/apache/imap.so

%files ldap
%defattr(-,root,root)
/usr/lib/apache/ldap.so

%files manual
%defattr(-,root,root)
%doc doc/*

%changelog
* Mon May 08 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.0.16-3mdk
- added Prereq so it doesn't complain about missing php3.ini
- rebuild with EAPI 2.6.4 (bugfixes)
- include /usr/bin/* 
- removed old manual from sources

* Thu Apr  6 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.0.16-2mdk
- rebuit with EAPI 2.6.3
- moved doc
- added -DHAVE_PQCMDTUPLES
- put ldap in separate module

* Thu Apr  6 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.0.16-1mdk
- 3.0.16 bugfix release

* Mon Apr  3 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.0.15-4mdk
- fixed group
- created MySQL as a separate module to fix dependancies

* Tue Feb 29 2000 Jean-Michel Dault <jmdault@netrevolution.com> 3.0.15-3mdk
- rebuild for EAPI 2.6.1
- updated manual

* Mon Feb 27 2000 Jean-Michel Dault <jmdault@netrevolution.com> 3.0.15-2mdk
- re-made gd+ttf patch. (again)

* Mon Feb 27 2000 Jean-Michel Dault <jmdault@netrevolution.com> 3.0.15-1mdk
- added many BuildRequires (this is a very complex package!)
- upgraded to 3.0.15 (security updates)
- updated mysql client to 3.22.32
- added patch suggested by jeff b <jeff@univrel.pr.uconn.edu> to
  decrease the TOKEN_BITS from 20 to 18. This allows large applications
  written in PHP to not bomb out due to running out of tokens.

* Tue Jan 18 2000 Jean-Michel Dault <jmdault@netrevolution.com>
- upgraded to 3.0.14
- updated mysql client to 3.22.30
- added support for ftp

* Mon Jan  3 2000 Jean-Michel Dault <jmdault@netrevolution.com>
- final cleanup for Mandrake 7

* Mon Jan 3 2000 Jean-Michel Dault <jmdault@netrevolution.com>
- upgraded to 3.0.13
- fixed png support
- fixed reversed ttf fonts
- fixed imap and pgsql for good, made apache restart when installing these
  packages
- updated mysql client to 3.22.29

* Thu Dec 30 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- rebuilt for Oxygen and new mm-1.0.12 in Apache
- added ttf and t1lib, which are now part of Mandrake
- added gd support (png only, to enable gifs, you have to rebuild the rpm
  with the old library)

* Fri Sep 3 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- rebuilt for new mm-1.0.10 in Apache

* Thu Aug 26 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- added Conflicts line

* Fri Aug 19 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- Solaris adaptations

* Wed Aug 18 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- modified post scripts

* Sat Jul 31 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- upgraded to 3.0.12

* Wed Jul 21 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- upgraded to 3.0.11
- added RPM_OPT_FLAGS
- added fr locale
- "mandrakized" package again

* Mon Jun 14 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 3.0.9
- fixed postgresql module and made separate package
- separated manual into separate documentation package

* Mon May 24 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 3.0.8, which fixes problems with glibc 2.1.
- took some ideas grom Gomez's RPM.

* Tue May 04 1999 Preston Brown <pbrown@redhat.com>
- hacked in imap support in an ugly way until imap gets an official
  shared library implementation

* Fri Apr 16 1999 Preston Brown <pbrown@redhat.com>
- pick up php3.ini

* Wed Mar 24 1999 Preston Brown <pbrown@redhat.com>
- build against apache 1.3.6

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 2)

* Mon Mar 08 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 3.0.7.

* Wed Feb 24 1999 Preston Brown <pbrown@redhat.com>
- Injected new description and group.

* Sun Feb 07 1999 Preston Brown <pbrown@redhat.com>
- upgrade to php 3.0.6, built against apache 1.3.4

* Mon Oct 12 1998 Cristian Gafton <gafton@redhat.com>
- rebuild for apache 1.3.3

* Thu Oct 08 1998 Preston Brown <pbrown@redhat.com>
- updated to 3.0.5, fixes nasty bugs in 3.0.4.

* Sun Sep 27 1998 Cristian Gafton <gafton@redhat.com>
- updated to 3.0.4 and recompiled for apache 1.3.2

* Thu Sep 03 1998 Preston Brown <pbrown@redhat.com>
- improvements; builds with apache-devel package installed.

* Tue Sep 01 1998 Preston Brown <pbrown@redhat.com>
- Made initial cut for PHP3.
